'From MIT Squeak 0.9.4 (June 1, 2003) [latest update: #20091122] on 22 November 2009 at 9:57:36 pm'!
CommandBlockMorph subclass: #CBlockMorph
	instanceVariableNames: 'nestedBlock nextBlock topBarBottom blockBottom loopMorph stretchHeight endMorph '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scratch-Blocks'!
CommandBlockMorph subclass: #IfElseBlockMorph
	instanceVariableNames: 'trueBlock falseBlock nextBlock elseLabel elseBarY topBarBottom blockBottom elseMorph endMorph '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scratch-Blocks'!
ArgMorph subclass: #VariableRefArgMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scratch-Blocks'!

!BlockMorph class methodsFor: 'class initialization' stamp: 'e-itoh 11/22/2009 14:46'!
initialize
	"self initialize"

	LabelColor _ Color white.

	PuzzleInset _ 11.
	PuzzleWidth _ 14.
	CBlockBracketThickness _ 20. "12 e-itoh"

	DebugMenu _ false.
! !


!CommandBlockMorph methodsFor: 'private' stamp: 'e-itoh 11/22/2009 15:25'!
uncoloredArgMorphFor: specString
	"Answer an argument morph for the given argument specification string."

	| code |
	code _ specString at: 2.
	$a = code ifTrue: [^ AttributeArgMorph new choice: 'volume'].
	$b = code ifTrue: [^ BooleanArgMorph new].
	$c = code ifTrue: [^ ColorArgMorph new showPalette: true].
	$C = code ifTrue: [^ ColorArgMorph new showPalette: false].  "don't use palette; pick from screen"
	$d = code ifTrue: [^ ExpressionArgMorphWithMenu new numExpression: '0'; menuSelector: #directionMenu].
	$D = code ifTrue: [^ ExpressionArgMorphWithMenu new numExpression: '48'; menuSelector: #midiDrumMenu].
	$e = code ifTrue: [^ EventTitleMorph new].
	$f = code ifTrue: [^ ChoiceArgMorph new getOptionsSelector: #mathFunctionNames; choice: 'sqrt'].
	$g = code ifTrue: [^ ChoiceArgMorph new getOptionsSelector: #graphicEffectNames; choice: 'color'].
	$H = code ifTrue: [^ ChoiceArgMorph new getOptionsSelector: #hookupSensorNames].
	$h = code ifTrue: [^ ChoiceArgMorph new getOptionsSelector: #hookupBooleanSensorNames].
	$I = code ifTrue: [^ ExpressionArgMorphWithMenu new numExpression: '1'; menuSelector: #midiInstrumentMenu].
	$i = code ifTrue: [^ ExpressionArgMorphWithMenu new numExpression: '1'; menuSelector: #listIndexMenu].
	$k = code ifTrue: [^ ChoiceArgMorph new getOptionsSelector: #keyNames; choice: 'space'].
	$L = code ifTrue: [^ ChoiceArgMorph new getOptionsSelector: #listVarMenu].
	$l = code ifTrue: [^ ChoiceOrExpressionArgMorph new getOptionsSelector: #costumeNames; choice: 'costume1'].
	$m = code ifTrue: [^ SpriteArgMorph new].
	$M = code ifTrue: [^ ChoiceArgMorph new getOptionsSelector: #motorNames].
	$n = code ifTrue: [^ ExpressionArgMorph new numExpression: '10'].
	$N = code ifTrue: [^ ExpressionArgMorphWithMenu new numExpression: '60'; menuSelector: #noteSelector].
	$s = code ifTrue: [^ ExpressionArgMorph new stringExpression: ''].
	$S = code ifTrue: [^ ChoiceOrExpressionArgMorph new getOptionsSelector: #soundNames; choice: 'pop'].
	$v = code ifTrue: [^ ChoiceArgMorph new getOptionsSelector: #varNamesMenu; choice: ''].
	$V = code ifTrue: [^ VariableRefArgMorph new].
	$W = code ifTrue: [^ ChoiceArgMorph new getOptionsSelector: #motorDirection].
	$x = code ifTrue: [^ ChoiceOrExpressionArgMorph new getOptionsSelector: #sceneNames; choice: ''].
	$y = code ifTrue: [^ ExpressionArgMorphWithMenu new numExpression: '1'; menuSelector: #listIndexForDeleteMenu].

	^ ExpressionArgMorph new numExpression: '10'
! !


!CBlockMorph methodsFor: 'drawing' stamp: 'e-itoh 11/22/2009 14:49'!
fixBlockLayout
	"Update the positions of my submorphs."

	| oldExtent newW newH f |
	blockLayoutNeeded ifFalse: [^ self].
	super fixBlockLayout.

	"fix nestedBlock and nextBlock in case they've been removed from me"
	(nestedBlock notNil and: [nestedBlock owner ~~ self]) ifTrue: [nestedBlock _ nil].
	(nextBlock notNil and: [nextBlock owner ~~ self]) ifTrue: [nextBlock _ nil].

	oldExtent _ self extent.
	newW _ oldExtent x max: 40.
	newH _ self topBarHeight + CBlockBracketThickness.
	self isForever ifFalse: [newH _ newH + 4].

	nestedBlock
		ifNil: [newH _ newH + 14]
		ifNotNil: [
			stretchHeight _ 0.
			nestedBlock fixBlockLayout.
			newH _ newH + nestedBlock fullBounds height - 1.
			ScratchTranslator isRTL
				ifTrue: [nestedBlock position: self topRight - ((CBlockBracketThickness + nestedBlock width)@0)
					+ (0@(self topBarHeight + 3))]
				ifFalse: [nestedBlock position: self position + (CBlockBracketThickness@(self topBarHeight + 3))].
			nestedBlock blockSequence last isStopOrForever ifTrue: [newH _ newH + 4]].
	self extent: newW@newH + (0@stretchHeight).
	ScratchTranslator isRTL ifTrue: [
		self left: self left + (oldExtent x - newW)].

	"position loop morph"
	loopMorph ifNotNil: [
		f _ ScratchFrameMorph skinAt: #loopIcon.
		ScratchTranslator isRTL
			ifTrue: [loopMorph form: (f flipBy: #horizontal centerAt: f center)]
			ifFalse: [loopMorph form: f].
		self isForever
			ifTrue: [ScratchTranslator isRTL
				ifTrue: [loopMorph position: self bottomLeft + (4@0) - (0@(loopMorph height + 2))]
				ifFalse: [loopMorph position: self bottomRight - loopMorph extent - (4@2)]]
			ifFalse: [ScratchTranslator isRTL
				ifTrue: [loopMorph position: self bottomLeft + (4@0) - (0@(loopMorph height + 6))]
				ifFalse: [loopMorph position: self bottomRight - loopMorph extent - (4@6)]]].

	nextBlock ifNotNil: [
		ScratchTranslator isRTL
			ifTrue: [nextBlock position: (self right - nextBlock width)@(self bottom - 4)]
			ifFalse: [nextBlock position: self left@(self bottom - 4)]].
	endMorph position: (self left + 6)@(self bottom - CBlockBracketThickness - 2)! !

!CBlockMorph methodsFor: 'private' stamp: 'e-itoh 11/22/2009 14:48'!
addLabel
	"Also add the end label"

	super addLabel.
	endMorph _ self labelMorphFor: 'end' localized.
	self addMorphBack: endMorph.
! !


!IfElseBlockMorph methodsFor: 'private' stamp: 'e-itoh 11/22/2009 14:48'!
addLabel
	"Also add the else label"

	super addLabel.
	elseMorph _ self labelMorphFor: 'else' localized.
	self addMorphBack: elseMorph.
	endMorph _ self labelMorphFor: 'end' localized.
	self addMorphBack: endMorph.
! !

!IfElseBlockMorph methodsFor: 'private' stamp: 'e-itoh 11/22/2009 14:49'!
fixBlockLayout
	"Update the positions of my submorphs."

	| newH |
	blockLayoutNeeded ifFalse: [^ self].

	"fix trueBlock, falseBlock, and nextBlock in case they've been removed from me"
	(trueBlock notNil and: [trueBlock owner ~~ self]) ifTrue: [trueBlock _ nil].
	(falseBlock notNil and: [falseBlock owner ~~ self]) ifTrue: [falseBlock _ nil].
	(nextBlock notNil and: [nextBlock owner ~~ self]) ifTrue: [nextBlock _ nil].

	super fixBlockLayout.
	newH _ self topBarHeight + 3.

	trueBlock
		ifNil: [newH _ newH + 15]
		ifNotNil: [
			trueBlock fixBlockLayout.
			ScratchTranslator isRTL
				ifTrue: [trueBlock position: (self right - trueBlock width - CBlockBracketThickness)@(self top + newH)]
				ifFalse: [trueBlock position: self position + (CBlockBracketThickness@newH)].
			newH _ newH + trueBlock fullBounds height.
			trueBlock blockSequence last isStopOrForever ifTrue: [newH _ newH + 4]].

	elseBarY _ newH - 4.
	newH _ newH + self elseBarHeight + 1.

	falseBlock
		ifNil: [newH _ newH + 15]
		ifNotNil: [
			falseBlock fixBlockLayout.
			ScratchTranslator isRTL
				ifTrue: [falseBlock position: (self right - falseBlock width - CBlockBracketThickness)@(self top + newH)]
				ifFalse: [falseBlock position: self position + (CBlockBracketThickness@newH)].
			newH _ newH + falseBlock fullBounds height.
			falseBlock blockSequence last isStopOrForever ifTrue: [newH _ newH + 4]].

	newH _ newH + CBlockBracketThickness.
	self height: newH.
	nextBlock ifNotNil: [ScratchTranslator isRTL
		ifTrue: [nextBlock position: (self right - nextBlock width)@(self bottom - 4)]
		ifFalse: [nextBlock position: self left@(self bottom - 4)]].

	ScratchTranslator isRTL
		ifTrue: [elseMorph position: (self right - elseMorph width - 6)@(self top + elseBarY
			+ ((ScratchTranslator centerOffsetForButtonWithFont: (ScratchFrameMorph getFont: #Label)) // 4))]
		ifFalse: [elseMorph position: (self left + 6)@(self top + elseBarY
			+ ((ScratchTranslator centerOffsetForButtonWithFont: (ScratchFrameMorph getFont: #Label)) // 4))].
	endMorph position: (self left + 6)@(self bottom - CBlockBracketThickness - 2)! !


!SetterBlockMorph methodsFor: 'evaluation' stamp: 'e-itoh 11/22/2009 21:54'!
argumentCount
	^ 2! !


!VariableRefArgMorph methodsFor: 'as yet unclassified' stamp: 'e-itoh 11/22/2009 19:52'!
evaluate
	^ false! !

!VariableRefArgMorph methodsFor: 'as yet unclassified' stamp: 'e-itoh 11/22/2009 15:28'!
initialize

	super initialize.
	self borderInset.
	self borderWidth: 1.
	self color: Color brown.

	labelMorph _ StringMorph new
		font: (ScratchFrameMorph getFont: #Arg);
		forceUnicodeRendering: true;
		color: Color white.
	self addMorph: labelMorph.
	labelMorph contents: 'var'.
	labelMorph position: self position + borderWidth + (3 @ -1).
	self extent: (labelMorph extent + (16@2) + borderWidth).
! !

!VariableRefArgMorph methodsFor: 'as yet unclassified' stamp: 'e-itoh 11/22/2009 20:04'!
step
	owner
		submorphsDo: [:each | (each isKindOf: ChoiceArgMorph)
				ifTrue: 
					[labelMorph contents: each choice.
					labelMorph position: self position + borderWidth + (3 @ -1).
					self extent: labelMorph extent + (16 @ 2) + borderWidth.
					^ self]]! !

!VariableRefArgMorph methodsFor: 'as yet unclassified' stamp: 'e-itoh 11/22/2009 20:03'!
stepTime
	^ 500! !

BlockMorph initialize!
